require "Penetrator"
require 'lovedebug'

function love.load()
	 love.window.setMode(800,600,{vsync=false})
	 love.keyboard.setKeyRepeat(true)
	 light={x=400,y=300}
	 reload = 0
	 omap='first'
	 map='first'
	 loaded=false
end

function love.update(dt)
	 if omap ~= map then
		 loaded = false
	 end
	 if not loaded then
		 if map == 'first' then
			 wall={
				 --creates boarders
				 newRect(-10,0,10,love.window.getHeight()),
				 newRect(0,-10,love.window.getWidth(),10),
				 newRect(love.window.getWidth(),0,10,love.window.getHeight()),
				 newRect(0,love.window.getHeight(),love.window.getWidth(),10),
				 --creates on screen walls
				 newRect(350,100,100,100),
				 newRect(250,100,100,100),
				 newRect(150,100,100,100),
				 newRect(50,100,100,100),
				 newRect(50,200,100,100),
				 newRect(50,300,100,100),
				 newRect(50,400,100,100),
				 newRect(150,400,100,100),
				 newRect(150,500,100,100),
				 newRect(250,500,100,100),
				 newRect(350,500,100,100),
				 newRect(350,400,100,100),
				 newRect(450,400,100,100),
				 newRect(550,400,100,100),
				 newRect(650,400,100,100),
				 newRect(650,300,100,100),
				 newRect(650,200,100,100),
				 newRect(650,100,100,100),
				 newRect(550,100,100,100),
				 newRect(550,0,100,100),
				 newRect(450,0,100,100),
				 newRect(350,0,100,100),
			 }
		 end
		 if map == 'sandbox' then
			 wall={
				 --creates boarders
				 newRect(-10,0,10,love.window.getHeight()),
				 newRect(0,-10,love.window.getWidth(),10),
				 newRect(love.window.getWidth(),0,10,love.window.getHeight()),
				 newRect(0,love.window.getHeight(),love.window.getWidth(),10),
			 }
		 end 
		 
		 loaded = true
		 reload = 0
		 omap = map
	 end
	 if reload<1 or isOn then 
		 if isOn then
			 moveRect(wall[isOn],love.mouse.getX()-diffx,love.mouse.getY()-diffy)
			 reload=0
		 end
		 side={}
		 edge={}
		 visible={}
		 visible.side={}
		 visible.edge={}
		 for i,v in ipairs(wall) do
			 side[i]={}
			 side[i][1]={v.x,v.y, v.x,v.y+v.height}
			 side[i][2]={v.x,v.y, v.x+v.width,v.y}
			 side[i][3]={v.x+v.width,v.y, v.x+v.width,v.y+v.height}
			 side[i][4]={v.x,v.y+v.height, v.x+v.width,v.y+v.height}
			 visible.side[i]={}
			 for ii,vv in ipairs(side[i]) do
				 if hasPLOS(ii,i) then
					 table.insert(visible.side[i],ii)
				 end
			 end
			 edge[i]={}
			 edge[i][1]={side[i][2][1],side[i][2][2]}
			 edge[i][2]={side[i][2][3],side[i][2][4]}
			 edge[i][3]={side[i][4][3],side[i][4][4]}
			 edge[i][4]={side[i][4][1],side[i][4][2]}
			 visible.edge[i]={}
			 for ii,vv in ipairs(visible.side[i]) do
				 if vv == 1 then
					 table.insert(visible.edge[i],4)
					 table.insert(visible.edge[i],1)
				 elseif vv == 2 then
					 table.insert(visible.edge[i],1)
					 table.insert(visible.edge[i],2)
				 elseif vv == 3 then
					 table.insert(visible.edge[i],2)
					 table.insert(visible.edge[i],3)
				 elseif vv == 4 then
					 table.insert(visible.edge[i],3)
					 table.insert(visible.edge[i],4)
				 end
			 end
			 local tempt=visible.edge[i]
			 for ii=1,4 do
				 local isrepeat
				 for iii,vvv in ipairs(visible.edge[i]) do
					 if visible.edge[i][iii] == ii then
						 if isrepeat then
							 table.remove(tempt,iii)
						 else
							 isrepeat=true
						 end
					 end
				 end
			 end
			 visible.edge[i]=tempt
		 end
		 reload=1
	 end
	 if love.keyboard.isDown('left') then
		 light.x = light.x - 100 *dt
		 reload=0
	 end
	 if love.keyboard.isDown('right') then
		 light.x = light.x + 100 *dt
		 reload=0
	 end
	 if love.keyboard.isDown('up') then
		 light.y = light.y - 100 *dt
		 reload=0
	 end
	 if love.keyboard.isDown('down') then
		 light.y = light.y + 100 *dt
		 reload=0
	 end
end

function love.draw()
	 for i,v in ipairs(wall) do
		 love.graphics.setColor(255,255,255,255)
		 love.graphics.rectangle('fill',returnRect(v))
		 love.graphics.setColor(0,0,0)
		 love.graphics.print(i,v.x+50,v.y+50)
	 end
	 love.graphics.setColor(255,0,127)
	 for i,v in ipairs(visible.side) do
		 for ii=1,#v do
			 love.graphics.line(side[i][v[ii]])
		 end
	 end
	 love.graphics.setColor(255,255,0)
	 for i,v in ipairs(visible.edge) do
		 for ii,vv in ipairs(v) do
			 if vv == 1 then
				 if hasLOS({light.x,light.y,edge[i][1][1]-0.005,edge[i][1][2]-0.005},i,1,1) or hasLOS({light.x,light.y,edge[i][1][1]+0.005,edge[i][1][2]-0.005},i,1,2) or hasLOS({light.x,light.y,edge[i][1][1]-0.005,edge[i][1][2]+0.005},i,1,3) then
					 love.graphics.setColor(255,255,0)
					 love.graphics.circle('fill',edge[i][1][1],edge[i][1][2],3,32)
					 love.graphics.line({light.x,light.y,edge[i][1][1],edge[i][1][2]})
					 local raycast
					 raycastp={}
					 if method == 1 then
						 raycast = {light.x,light.y,edge[i][1][1]-0.005,edge[i][1][2]-0.005}
					 elseif method == 2 then
						 raycast = {light.x,light.y,edge[i][1][1]+0.005,edge[i][1][2]-0.005}
					 elseif method == 3 then
						 raycast = {light.x,light.y,edge[i][1][1]-0.005,edge[i][1][2]+0.005}
					 end
					 
					 raycastp={}
					 local dist={}
					 for iii,vvv in ipairs(visible.side) do
						 if iii ~= i then
							 for i4,v4 in ipairs(vvv) do
								 if raycast[1] > raycast[3] and raycast[2] == raycast[4] then
									 if side[iii][v4][1] < raycast[3] then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] == raycast[3] and raycast[2] > raycast[4] then
									 if not (side[iii][v4][2] > raycast[3]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] < raycast[3] and raycast[2] > raycast[4] then --4
									 if not (side[iii][v4][1] < raycast[1] and side[iii][v4][4] > raycast[2]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] < raycast[3] and raycast[2] == raycast[4] then
									 if not (side[iii][v4][3] < raycast[3]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] == raycast[3] and raycast[2] < raycast[4] then
									 if not (side[iii][v4][4] < raycast[2]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] > raycast[3] and raycast[2] < raycast[4] then
									 if not (side[iii][v4][3] > raycast[1] and side[iii][v4][2] < raycast[2]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 end
								 --table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
								 --table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
							 end
						 end
					 end
					 dist=sort(dist)
					 local realp=getRealPoint(dist,raycastp)
					 if #raycastp > 0 and realp then
						 love.graphics.setColor(0,255,255)
						 love.graphics.circle('fill',raycastp[dist[realp].pos].x,raycastp[dist[realp].pos].y,3,32)
						 love.graphics.line(edge[i][1][1],edge[i][1][2],raycastp[dist[realp].pos].x,raycastp[dist[realp].pos].y)
					 end
				 else
					 love.graphics.setColor(255,0,0)
					 love.graphics.circle('fill',edge[i][1][1],edge[i][1][2],3,32)
					 love.graphics.line({light.x,light.y,edge[i][1][1],edge[i][1][2]})
					 if point then
						 love.graphics.setColor(0,255,0)
						 love.graphics.circle('fill',point.x,point.y,3,32)
					 end
				 end
			 elseif vv == 2 then
				 if hasLOS({light.x,light.y,edge[i][2][1]+0.005,edge[i][2][2]-0.005},i,2,1) or hasLOS({light.x,light.y,edge[i][2][1]-0.005,edge[i][2][2]-0.005},i,2,2) or  hasLOS({light.x,light.y,edge[i][2][1]+0.005,edge[i][2][2]+0.005},i,2,3) then
					 love.graphics.setColor(255,255,0)
					 love.graphics.circle('fill',edge[i][2][1],edge[i][2][2],3,32)
					 love.graphics.line({light.x,light.y,edge[i][2][1],edge[i][2][2]})
					 
					 local raycast
					 raycastp={}
					 if method == 1 then
						 raycast = {light.x,light.y,edge[i][vv][1]-0.005,edge[i][vv][2]-0.005}
					 elseif method == 2 then
						 raycast = {light.x,light.y,edge[i][vv][1]+0.005,edge[i][vv][2]-0.005}
					 elseif method == 3 then
						 raycast = {light.x,light.y,edge[i][vv][1]-0.005,edge[i][vv][2]+0.005}
					 end
					 
					 raycastp={}
					 local dist={}
					 for iii,vvv in ipairs(visible.side) do
						 if iii ~= i then
							 for i4,v4 in ipairs(vvv) do
								 if raycast[1] > raycast[3] and raycast[2] == raycast[4] then
									 if side[iii][v4][1] < raycast[3] then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] > raycast[3] and raycast[2] > raycast[4] then --2
									 if not (side[iii][v4][3] > raycast[1] and side[iii][v4][4] > raycast[2]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] == raycast[3] and raycast[2] > raycast[4] then
									 if not (side[iii][v4][2] > raycast[3]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] < raycast[3] and raycast[2] == raycast[4] then
									 if not (side[iii][v4][3] < raycast[3]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] < raycast[3] and raycast[4] > raycast[2] then --6
									 if not (side[iii][v4][1] < raycast[1] and  side[iii][v4][2] < raycast[2]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] == raycast[3] and raycast[2] < raycast[4] then
									 if not (side[iii][v4][4] < raycast[2]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 end
								 --table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
								 --table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
							 end
						 end
					 end
					 dist=sort(dist)
					 local realp=getRealPoint(dist,raycastp)
					 if raycastp and realp then
						 love.graphics.setColor(0,255,255)
						 love.graphics.circle('fill',raycastp[dist[realp].pos].x,raycastp[dist[realp].pos].y,3,32)
						 love.graphics.line(edge[i][vv][1],edge[i][vv][2],raycastp[dist[realp].pos].x,raycastp[dist[realp].pos].y)
					 end
				 else
					 love.graphics.setColor(255,0,0)
					 love.graphics.circle('fill',edge[i][2][1],edge[i][2][2],3,32)
					 love.graphics.line({light.x,light.y,edge[i][2][1],edge[i][2][2]})
					 if point then
						 love.graphics.setColor(0,255,0)
						 love.graphics.circle('fill',point.x,point.y,3,32)
					 end
				 end
			 elseif vv == 3 then
				 if hasLOS({light.x,light.y,edge[i][3][1]+0.005,edge[i][3][2]+0.005},i,3,1) or hasLOS({light.x,light.y,edge[i][3][1]+0.005,edge[i][3][2]-0.005},i,3,2) or hasLOS({light.x,light.y,edge[i][3][1]-0.005,edge[i][3][2]+0.005},i,3,3) then
					 love.graphics.setColor(255,255,0)
					 love.graphics.circle('fill',edge[i][3][1],edge[i][3][2],3,32)
					 love.graphics.line({light.x,light.y,edge[i][3][1],edge[i][3][2]})
					 local raycast
					 raycastp={}
					 if method == 1 then
						 raycast = {light.x,light.y,edge[i][vv][1]-0.005,edge[i][vv][2]-0.005}
					 elseif method == 2 then
						 raycast = {light.x,light.y,edge[i][vv][1]+0.005,edge[i][vv][2]-0.005}
					 elseif method == 3 then
						 raycast = {light.x,light.y,edge[i][vv][1]-0.005,edge[i][vv][2]+0.005}
					 end
					 
					 raycastp={}
					 local dist={}
					 for iii,vvv in ipairs(visible.side) do
						 if iii ~= i then
							 for i4,v4 in ipairs(vvv) do
								 if raycast[1] > raycast[3] and raycast[2] == raycast[4] then
									 if side[iii][v4][1] < raycast[3] then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] == raycast[3] and raycast[2] > raycast[4] then
									 if not (side[iii][v4][2] > raycast[3]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] < raycast[3] and raycast[2] > raycast[4] then --4
									 if not (side[iii][v4][1] < raycast[1] and side[iii][v4][4] > raycast[2]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] < raycast[3] and raycast[2] == raycast[4] then
									 if not (side[iii][v4][3] < raycast[3]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] == raycast[3] and raycast[2] < raycast[4] then
									 if not (side[iii][v4][4] < raycast[2]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] > raycast[3] and raycast[2] < raycast[4] then --8
									 if not (side[iii][v4][3] > raycast[1] and side[iii][v4][2] < raycast[2]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end--[[
								 else
									 error('No condition was found for point 3')
									 print(raycast[1],raycast[2],raycast[3],raycast[4])]]
								 end
								 --table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
								 --table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
							 end
						 end
					 end
					 dist=sort(dist)
					 local realp=getRealPoint(dist,raycastp)
					 if raycastp and realp then
						 love.graphics.setColor(0,255,255)
						 love.graphics.circle('fill',raycastp[dist[realp].pos].x,raycastp[dist[realp].pos].y,3,32)
						 love.graphics.line(edge[i][vv][1],edge[i][vv][2],raycastp[dist[realp].pos].x,raycastp[dist[realp].pos].y)
					 end
				 else
					 love.graphics.setColor(255,0,0)
					 love.graphics.circle('fill',edge[i][3][1],edge[i][3][2],3,32)
					 love.graphics.line({light.x,light.y,edge[i][3][1],edge[i][3][2]})
					 if point then
						 love.graphics.setColor(0,255,0)
						 love.graphics.circle('fill',point.x,point.y,3,32)
					 end
				 end
			 elseif vv == 4 then
				 if hasLOS({light.x,light.y,edge[i][4][1]-0.005,edge[i][4][2]+0.005},i,4,1) or hasLOS({light.x,light.y,edge[i][4][1]+0.005,edge[i][4][2]+0.005},i,4,2) or hasLOS({light.x,light.y,edge[i][4][1]-0.005,edge[i][4][2]-0.005},i,4,3)then
					 love.graphics.setColor(255,255,0)
					 love.graphics.circle('fill',edge[i][4][1],edge[i][4][2],3,32)
					 love.graphics.line({light.x,light.y,edge[i][4][1],edge[i][4][2]})
					 local raycast
					 raycastp={}
					 if method == 1 then
						 raycast = {light.x,light.y,edge[i][vv][1]-0.005,edge[i][vv][2]-0.005}
					 elseif method == 2 then
						 raycast = {light.x,light.y,edge[i][vv][1]+0.005,edge[i][vv][2]-0.005}
					 elseif method == 3 then
						 raycast = {light.x,light.y,edge[i][vv][1]-0.005,edge[i][vv][2]+0.005}
					 end
					 
					 raycastp={}
					 local dist={}
					 for iii,vvv in ipairs(visible.side) do
						 if iii ~= i then
							 for i4,v4 in ipairs(vvv) do
								 if raycast[1] > raycast[3] and raycast[2] == raycast[4] then
									 if side[iii][v4][1] < raycast[3] then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] > raycast[3] and raycast[2] > raycast[4] then --2
									 if not (side[iii][v4][3] > raycast[1] and side[iii][v4][4] > raycast[2]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] == raycast[3] and raycast[2] > raycast[4] then
									 if not (side[iii][v4][2] > raycast[3]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] < raycast[3] and raycast[2] == raycast[4] then --5
									 if not (side[iii][v4][3] < raycast[3]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] < raycast[3] and raycast[4] > raycast[2] then --6
									 if not (side[iii][v4][1] < raycast[1] and  side[iii][v4][2] < raycast[2]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 elseif raycast[1] == raycast[3] and raycast[2] < raycast[4] then
									 if not (side[iii][v4][4] < raycast[2]) then
										 table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
										 table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
									 end
								 else
									 --print(raycast[1],raycast[2],raycast[3],raycast[4])
									 --error('No condition was found for point 4')
								 end
								 --table.insert(raycastp, getInterPointCK(raycast,side[iii][v4]))
								 --table.insert(dist,{dist = math.sqrt(math.abs(raycast[3]-raycastp[#raycastp].x)^2+math.abs(raycast[4]-raycastp[#raycastp].y)^2), pos = #raycastp, wall = {iii,v4}})
							 end
						 end
					 end
					 dist=sort(dist)
					 local realp=getRealPoint(dist,raycastp)
					 if raycastp and realp then
						 love.graphics.setColor(0,255,255)
						 love.graphics.circle('fill',raycastp[dist[realp].pos].x,raycastp[dist[realp].pos].y,3,32)
						 love.graphics.line(edge[i][vv][1],edge[i][vv][2],raycastp[dist[realp].pos].x,raycastp[dist[realp].pos].y)
					 end
				 else
					 love.graphics.setColor(255,0,0)
					 love.graphics.circle('fill',edge[i][4][1],edge[i][4][2],3,32)
					 love.graphics.line({light.x,light.y,edge[i][4][1],edge[i][4][2]})
					 if point then
						 love.graphics.setColor(0,255,0)
						 love.graphics.circle('fill',point.x,point.y,3,32)
					 end
				 end
			 end
		 end
	 end
	 love.graphics.setColor(0,0,255)
	 love.graphics.circle('fill',light.x,light.y,3,32)
	 love.window.setTitle(love.timer.getFPS())
end

function love.mousepressed(x,y,k)
	 if k == 'l' then
		 for i=5,#wall do
			 if isIn(wall[i],x,y) then
				 diffx=(love.mouse.getX()-wall[i].x)
				 diffy=(love.mouse.getY()-wall[i].y)
				 isOn=i
			 end
		 end
	 end
	 if k=='r' then
		 table.insert(wall,newRect(x,y,100,100))
	 end
end
function love.mousereleased(x,y,k)
	 diffx=0
	 diffy=0
	 isOn=false
end

function hasLOS(line,debug1,debug2,methd)
	 for i,v in ipairs(side) do
		 for ii,vv in ipairs(visible.side[i]) do
			 _,point=isInterMW(line,side[i][vv])
			 method=methd
			 if _ then
				 if love.keyboard.isDown('lalt') then
					 print('wall no. '..debug1..' edge no. '..debug2..' collides with wall no. '..i..' side no. '..ii)
				 end
				 return false
			 end
		 end
	 end
	 return true
end

function hasPLOS(siden,walln)
	 for i,v in ipairs(side[walln]) do
		 if isInterMW({light.x,light.y,(side[walln][siden][1]+side[walln][siden][3])/2,(side[walln][siden][2]+side[walln][siden][4])/2},side[walln][i]) and i~=siden then
			 if love.keyboard.isDown('lalt') then
				 print('wall no. '..debug1..' edge no. '..debug2..' collides with wall no. '..i..' side no. '..ii)
			 end
			 return false
		 end
	 end
	 return true
end

function getRealPoint(sorted,points)
	 for i,v in ipairs(sorted) do
		 if isPointInLineLP({x=points[v.pos].x,y=points[v.pos].y},side[v.wall[1]][v.wall[2]]) then
			 return i
		 end
	 end
end

function sort(sorter)
	 local changed
	 repeat
		 changed=nil
		 for i=1,#sorter-1 do
			 if tonumber(sorter[i].dist) > tonumber(sorter[i+1].dist) then
				 local temp = sorter[i]
				 sorter[i]=sorter[i+1]
				 sorter[i+1]=temp
				 changed=true
			 end
		 end
		 changed = changed or false
	 until changed==false
	 return sorter
end
